#define EXTENDERVERSION 310000      // DLL version number.
#define INTERFACELEVEL  2
#define EXTENDER_FEATURE_LEVEL 1001
#define STRICT

/************************************************************************************/
/* Extender to define constants for dialogs.                                        */
/************************************************************************************/
#include <windows.h>
#include "wwwpform.h"
#include "addons.h"
/*---------------------------------------------------------------------------
                                    Defines
  ---------------------------------------------------------------------------*/


// helpful functions for displaying debugging message boxes
#define MBSS(p1, p2) {MessageBox(GetFocus(), (p2), (p1), MB_OK | MB_SETFOREGROUND);}
#define MBSN(p1, p2) {char szDebug[20]; MyLtoa((p2), szDebug, 10); MessageBox(GetFocus(), szDebug, (p1), MB_OK | MB_SETFOREGROUND);}

#define RETLONG(numb)         return (lpViperCallback(((lpViperReturn->x=numb)      +(lpViperReturn->inittype=VARTYPE_INT))      ?RESULT_SUCCESS:RESULT_SUCCESS, ViperInterfaceVersion, lpViperStruct, lpViperReturn))
#define RETSTRING(str)        return (lpViperCallback(((lpViperReturn->lpstr=str)   +(lpViperReturn->inittype=VARTYPE_STRING))   ?RESULT_SUCCESS:RESULT_SUCCESS, ViperInterfaceVersion, lpViperStruct, lpViperReturn))
#define RETERROR(sev, errnum) return (lpViperCallback(((LoadString(hinstDLL, (errnum), lpViperReturn->lpstr = szWork, sizeof(szWork)))+(lpViperReturn->inittype = VARTYPE_STRING)) ?(sev)         :(sev)         , ViperInterfaceVersion, lpViperStruct, lpViperReturn))
#define RETCANCEL return (-5)


/* Superstitious data field to bypass/ignore bugs in certain versions of
   Windows that cause the beginning of the data area to be overwritten.
   This field should be the first data area defined and linked. */
char szBugFiller[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

HINSTANCE hinstDLL;                    // DLL Instance saved

#define EXTENDERVERSION 10000

/*---------------------------------------------------------------------------
  Command Extension Table for this DLL
  ---------------------------------------------------------------------------*/
tablestruct CommandExtTable[] =
{
// ID   Type       Mask               Params/Value Size Name
//----------------------------------------------------------------------
  {0,   FUNCTION,  0x000000000000000, 0,    0, "dlgcVersion"                  },
  {1,   CONSTANT,  0x000000000000000, 0,    0, "dpo_dialog_init"              },
  {2,   CONSTANT,  0x000000000000000, 1,    0, "dpo_timer_event"              },
  {3,   CONSTANT,  0x000000000000000, 2,    0, "dpo_pushbutton_pushed"        },
  {4,   CONSTANT,  0x000000000000000, 3,    0, "dpo_radiobutton_selected"     },
  {5,   CONSTANT,  0x000000000000000, 4,    0, "dpo_checkbox_changed"         },
  {6,   CONSTANT,  0x000000000000000, 5,    0, "dpo_editbox_textchanged"      },
  {7,   CONSTANT,  0x000000000000000, 5,    0, "dpo_multilinebox_textchanged" },
  {8,   CONSTANT,  0x000000000000000, 6,    0, "dpo_filelistbox_fileselected" },
  {9,   CONSTANT,  0x000000000000000, 7,    0, "dpo_itembox_itemselected"     },
  {10,  CONSTANT,  0x000000000000000, 8,    0, "dpo_droplistbox_itemchanged"  },
  {11,  CONSTANT,  0x000000000000000, 9,    0, "dpo_calendar_datechanged"     },
  {12,  CONSTANT,  0x000000000000000, 10,   0, "dpo_spinner_numberchanged"    },
  {13,  CONSTANT,  0x000000000000000, 11,   0, "dpo_close"                    },
  {14,  CONSTANT,  0x000000000000000, 12,   0, "dpo_filelistbox_doubleclicked"},
  {15,  CONSTANT,  0x000000000000000, 13,   0, "dpo_itembox_doubleclicked"    },
  {16,  CONSTANT,  0x000000000000000, 1000, 0, "dpo_dialog_disable"           },
  {17,  CONSTANT,  0x000000000000000, 1001, 0, "dpo_background_changed"       },
  {18,  CONSTANT,  0x000000000000000, 1,    0, "dcget_value"                  },
  {19,  CONSTANT,  0x000000000000000, 3,    0, "dcget_text"                   },
  {20,  CONSTANT,  0x000000000000000, 5,    0, "dcget_itemlist"               },
  {21,  CONSTANT,  0x000000000000000, 6,    0, "dcget_item"                   },
  {22,  CONSTANT,  0x000000000000000, 8,    0, "dcget_spinner_value"          },
  {23,  CONSTANT,  0x000000000000000, 1,    0, "dcset_value"                  },
  {24,  CONSTANT,  0x000000000000000, 3,    0, "dcset_replace_text"           },
  {25,  CONSTANT,  0x000000000000000, 4,    0, "dcset_replace_title"          },
  {26,  CONSTANT,  0x000000000000000, 5,    0, "dcset_replace_list"           },
  {27,  CONSTANT,  0x000000000000000, 6,    0, "dcset_item_selected"          },
  {28,  CONSTANT,  0x000000000000000, 8,    0, "dcset_spinner_value"          },
  {29,  CONSTANT,  0x000000000000000, 14,   0, "dcset_add_item_sort"          },
  {30,  CONSTANT,  0x000000000000000, 15,   0, "dcset_remove_item"            },
  {31,  CONSTANT,  0x000000000000000, 0,    0, "dcstate_null"                 },
  {32,  CONSTANT,  0x000000000000000, 1,    0, "dcstate_set_focus"            },
  {33,  CONSTANT,  0x000000000000000, 2,    0, "dcstate_query_style"          },
  {34,  CONSTANT,  0x000000000000000, 3,    0, "dcstate_add_style"            },
  {35,  CONSTANT,  0x000000000000000, 4,    0, "dcstate_remove_style"         },
  {36,  CONSTANT,  0x000000000000000, 5,    0, "dcstate_get_focus"            },
  {37,  CONSTANT,  0x000000000000000, 1,    0, "dcstyle_invisible"            },
  {38,  CONSTANT,  0x000000000000000, 2,    0, "dcstyle_disabled"             },
  {39,  CONSTANT,  0x000000000000000, 4,    0, "dcstyle_listonly"             },
  {40,  CONSTANT,  0x000000000000000, 8,    0, "dcstyle_blockinput"           },
  {41,  CONSTANT,  0x000000000000000, 16,   0, "dcstyle_asterisk"             },
  {42,  CONSTANT,  0x000000000000000, 32,   0, "dcstyle_default"              },
  {43,  CONSTANT,  0x000000000000000, 64,   0, "dcstyle_digits"               },
  {44,  CONSTANT,  0x000000000000000, 128,  0, "dcstyle_flat"                 },
  //--------------------------------------------------------------------------
  {-1,         0,                  0, 0,    0, ""                             }
};

/************************************************************************************/
/************************************************************************************/
/************************************************************************************/


/*===========================================================================
                                    DllMain
  ===========================================================================*/

BOOL WINAPI DllMain(HANDLE hInst, DWORD dwReason, LPVOID lpReserved)

{

  hinstDLL = hInst;
  UNREFERENCED_PARAMETER(dwReason);
  UNREFERENCED_PARAMETER(lpReserved);
  return (TRUE);
}
/************************************************************************************/
/************************************************************************************/
/************************************************************************************/
/*===========================================================================
                               WILExtenderQuery

  WILExtenderQuery is an optional (but recommended) entry point.  It is used
  to provide helpful information to the WIL DLL and possibly other callers.
  ===========================================================================*/

DllExport LONG FAR PASCAL WILExtenderQuery
 (short  nRequest,                     // type of information being requested
  LPVOID lpvInfo,                      // information buffer
  LONG   nCount)                       // additional data
{
  char szWork[256];
  LONG        i;

  switch (nRequest)
  {
/*---------------------------------------------------------------------------
  case 1 is used to identify yourself to a caller.
  ---------------------------------------------------------------------------*/
    case 1:                            // version information
    {
      if ((lpvInfo) && (nCount > 0))
      {
        LoadString(hinstDLL, 1000, szWork, sizeof(szWork));
        lstrcpyn((LPSTR) lpvInfo, szWork, nCount);
      }

      return (EXTENDERVERSION);
    }

/*---------------------------------------------------------------------------
  case 2 is used to inform the WIL DLL of your preferred interface level.
  ---------------------------------------------------------------------------*/
    case 2:                            // preferred interface version
    {
      for (i = 0; i < nCount; i++)
        if (((LPLONG) lpvInfo)[i] == INTERFACELEVEL)  // found one we like
          return (INTERFACELEVEL);

      return (-1);                     // didn't find any we like
    }

/*---------------------------------------------------------------------------
  Return 0 for any unknown requests, or any requests you don't handle!
  ---------------------------------------------------------------------------*/
    default:
      return (0);
  }
}


/************************************************************************************/
/************************************************************************************/
/************************************************************************************/

/*===========================================================================
                                  WILExtender2
============================================================================*/

DllExport LONG FAR PASCAL WILExtender2
  (HWND            hWnd,                  // hWnd of parent application
  HINSTANCE       hInst,                  // hInstance of parent application
  LONG            ViperInterfaceVersion,  // WIL interface version
  short           CmdId,                  // identifies extender function being called
  LPVIPERCALLBACK lpViperCallback,        // pointer to return value callback function
  LPVIPERSTRUCT   lpViperStruct,          // pointer to information structure
  LPLONG          lpLong,                 // pointer to your 32 bits
  LPVIPERVAR      lpvvArg,                // pointer to parameter array
  LONG            nArgCount,              // parameter count for lpvvArg
  LPVIPERVAR      lpViperReturn)          // pointer to return value structure
{
  char szWork[256];                // some local storage,  We need this,


  switch (CmdId)                       // the "big switch" (cases < 0 are at the bottom)
  {


    case -1:                           // Initialization
    {
       return ((sizeof(CommandExtTable) / sizeof(tablestruct)) - 1);  // 1 extra at end
    }

/*---------------------------------------------------------------------------
  Case -2 is called repeatedly by the WIL extender.  On each call, one
  CommandTable entry is passed back to the WIL extender.
  ---------------------------------------------------------------------------*/
    case -2:                           // Loading table
    {
      LPTABLESTRUCT lpTable;
      UINT          j;

      lpTable = (LPTABLESTRUCT) lpvvArg;
      j = (UINT) nArgCount;

      if (CommandExtTable[j].ident == -1)
        return (0);

      if (lpTable)
      {
        lpTable->ident  = CommandExtTable[j].ident;
        lpTable->type   = CommandExtTable[j].type;
        lpTable->param1 = CommandExtTable[j].param1;
        lpTable->ulMask = CommandExtTable[j].ulMask;
        lpTable->size   = lstrlen((LPSTR) CommandExtTable[j].delim);
        CharLower(CommandExtTable[j].delim);
        lstrcpy((LPSTR) lpTable->delim, (LPSTR) CommandExtTable[j].delim);
      }

      return (1);
    }

/*---------------------------------------------------------------------------
  Case -3 is called during the WIL shutdown process.
  ---------------------------------------------------------------------------*/
    case -3:                           // shutdown
    {
      return (1);
    }

/****************************************************************************/
/****************************************************************************/
/****************************************************************************/

/*---------------------------------------------------------------------------
   Case 0  dlgcVersion() returns the version number
   --------------------------------------------------------------------------*/
   case 0:
      {
         RETLONG(EXTENDERVERSION);
      }
/*---------------------------------------------------------------------------
                                  default case
  ---------------------------------------------------------------------------*/
    default:                           // we shouldn't get here
    {
      RETERROR(-1, 901);               // Unknown function
    }
  }                                    // end of "big switch"
}
